#include "MC.h"

MC::MC(vector<int> & matrices)
{
	number = matrices.size() - 1;
	table = new int [number * number];
	this->matrices = matrices;

	if(matrices.size() < 2)
		cout << "There is just one way." << endl;
	else
	{
		doall();
		writeway(0,number - 1);
	}

	cout << "  -->  " << *gettable(0,number - 1) << endl;
}

void MC::doall()
{
	int res;

	for(int count = 0;count < number;count++)
		*gettable(count,count) = 0;

	for(int length = 2;length <= number;length++)
	{
		for(int start = 0;start <= number - length;start++)
		{
			*gettable(start,start + length - 1) = *gettable(start + 1,start + length - 1) + matrices[start] * matrices[start + 1] * matrices[start + length];
			*getway(start,start + length - 1) = start;

			for(int brpo = start + 1;brpo < start + length - 1;brpo++)
			{
				res = *gettable(start,brpo) + *gettable(brpo + 1,start + length - 1) +  matrices[start] * matrices[brpo + 1] * matrices[start + length];

				if(res < *gettable(start,start + length - 1))
				{
					*gettable(start,start + length - 1) = res;
					*getway(start,start + length - 1) = brpo;
				}
			}
				
		}
	}
}

void MC::writeway(int start,int end)
{
	int tst;
	if(end - start == 0)
	{
		cout << char('A' + start);
		return;
	}

	cout << '(';
	writeway(start,tst = *getway(start,end));
	writeway(tst = *getway(start,end) + 1,end);
	cout << ')';
}

MC::~MC()
{
	delete [] table;
}